<?php
@include_once('inc/config.php');
@include_once('inc/function.php');

//内部文字エンコード
@mb_internal_encoding('UTF-8');
//HTTP出力文字エンコーディング
@mb_http_output('UTF-8');

if(defined("CONF_READ")){
$sql = array();
/*=========================================*/
/* ERR MSG                                 */
/*=========================================*/
$msg = array(
'opt01' => 'テーブル最適化 - 成功',
'opt02' => 'テーブル最適化 - 失敗',
'idx01' => 'インデックス作成 - 成功',
'idx02' => 'インデックス作成 - 失敗',
'idx03' => 'インデックス作成 - 作成済み'
);

/*=========================================*/
/* テーブル最適化                          */
/*=========================================*/
$sql["opt"] = 'OPTIMIZE TABLE '.constant("DB_TABLE_LOG").','.constant("DB_COUNTER").','.constant("DB_TABLE_UA").','.constant("DB_TABLE_SETTING").','.constant("DB_CH_ID").','.constant("DB_CH_URL").','.constant("DB_EXCLUDE").';';

/*=========================================*/
/* インデックス作成                        */
/*=========================================*/
$sql["idx"] = 'ALTER TABLE '.constant("DB_TABLE_LOG").' ADD INDEX iddate (id, date);';
$sql["idx"] .= 'ALTER TABLE '.constant("DB_TABLE_LOG").' ADD INDEX date (date);';
$sql["idx"] .= 'ALTER TABLE '.constant("DB_TABLE_UA").' ADD INDEX ua_name (ua_name(50));';
$sql["idx"] .= 'ALTER TABLE '.constant("DB_TABLE_LOG").' ADD INDEX ua (ua);';
}

/*=========================================*/
/* SQL送信                                 */
/*=========================================*/
function q($sql_key){
	global $db,$sql,$msg;
	
	$flg = true;
	foreach (explode(";", $sql[$sql_key]) as $v) {
		if(!$flg) break;
		$v = trim($v);
		if(!$v){
			continue;
		}else{
			$v .= ";";
		}
		$v = @mb_convert_encoding($v, "UTF-8", "ASCII,JIS,UTF-8,EUC-JP,SJIS");
		$res = $db->query($v);
		if(DB::isError($res) && mysql_errno() !== 1061){
			$flg = false;
		}
	}
	if($flg){
		if(DB::isError($res) && mysql_errno() === 1061){
			echo '<p>&gt; '.$msg[$sql_key."03"].'</p>';
		}else{
			echo '<p>&gt; '.$msg[$sql_key."01"].'</p>';
		}
	}else{
		echo '<p class="err">&gt; '.$msg[$sql_key."02"].'</p>';
		echo '<p class="def">【エラー内容】</p>';
		echo '<p class="def">Error Message: <b>' . $res->getMessage() . "</b></p>\n";
		echo '<p class="def">Debug: <b>' . $res->getDebugInfo() . "</b></p>\n";
	}
	return $flg;
}

?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta name="robots" content="noindex,nofollow,noarchive">
<style type="text/css">
<!--
BODY {
	letter-spacing: 0.2em;
	font-family: Verdana, Arial, "MS UI Gothic", Osaka, Helvetica, sans-serif;
	background-color: #EEE;
	margin: 30px;
	padding: 0px;
	font-size: 12px;
	background-image: none;
}
A         { color: #36C; }
A:link    { text-decoration: none; }
A:visited { text-decoration: none; }
A:hover   { text-decoration: underline; color: #F30; }
p {
	margin-left: 30px;
	color: #00C;
}
.def{
	color: #333;
}
.err{
	color: #C00;
}
#copy{
	font-size: 10px;
	color: #333333;
	text-align: right;
}
//-->
</style>
<title>mogura - 高速化パッチ</title>
</head>
<body>
<h2>mogura - 高速化パッチ</h2>
<?php

flush();
if(defined("CONF_READ")){
	$_GET["step"] = isset($_GET["step"]) ? $_GET["step"] : "";
	switch ($_GET["step"]) {
	case 1:
	   echo '<p class="def">高速化パッチを実行します。</p>';
		// DB接続
		$db = DB::connect(constant("DSN"));
		if(DB::isError($db)){
			echo '<p class="err">&gt; データベース［<b>'.(defined("DB_NAME_MOGURA") ? constant("DB_NAME_MOGURA") : constant("DB_NAME")).'</b>］に接続出来ませんでした</p>';
			echo '<p class="err">&gt; config.phpのデータベースの設定を見直してください</p>';
			echo '<p class="err">&gt; データベース［<b>'.(defined("DB_NAME_MOGURA") ? constant("DB_NAME_MOGURA") : constant("DB_NAME")).'</b>］が作成されているか確認して下さい</p>';
			echo '<p class="def">【エラー内容】</p>';
			echo '<p class="def">Error Message: <b>' . $db->getMessage() . "</b></p>\n";
			echo '<p class="def">Debug: <b>' . $db->getDebugInfo() . "</b></p>\n";
		   echo '<p class="def"><a href="mogpatch.php">戻る</a></p>';
		}else{
			$db->query("SET NAMES utf8;");
			$db_flg = true;
			echo '<p>&gt; DB接続</p>';
			if($db_flg) $db_flg = q("opt");
			if($db_flg) $db_flg = q("idx");
			
			$db->disconnect();
			echo '<p>&gt; DB切断</p>';
			
			if($db_flg){
				echo '<p class="def"><a href="mogpatch.php?step=2">次へ</a></p>';
			}else{
				echo '<p class="def"><a href="mogpatch.php?step=3">次へ</a></p>';
			}
		}
	   break;
	case 2:
		echo '<p>高速化パッチは正常に実行されました。</p>';
		echo '<p class="def"><b>「mogpatch.php」</b>をサーバーから削除してください。</p>';
		echo '<p class="def">□ <a href="control_panel/cp.php?mode=log_w">ログ取得用コード確認ページを開く</a>（コントロールパネル）</p>';
		echo '<p class="def">□ <a href="w3a.php">Moguraメイン画面を開く</a></p>';
		echo '<p class="def">□ <a href="mogpatch.php">mogpatch.phpトップ</a></p>';
	   break;
	case 3:
		echo '<p class="err">高速化パッチの実行に失敗しました。</p>';
		echo '<p class="def">□ <a href="mogpatch.php">mogpatch.phpトップ</a></p>';
	   break;


	default:
	   echo '<p class="def">深夜や早朝など、サーバの負荷が低い時間帯に実行することをお勧めします。</p>';
	   echo '<p class="err">高速化パッチを実行しますか？</p>';
	   echo '<p class="def"><a href="mogpatch.php">いいえ</a>｜<a href="mogpatch.php?step=1">はい</a></p>';
	   break;
	}
}else{
	echo '<p class="err">config.phpの読み込みに失敗しました。</p>';
}
?>
<div id="copy"><hr size="1"><a href="https://raihon.com/" target="_blank">raihon</a></div>
</body>
</html>
